<?php
// AShop
// Copyright 2019 - AShop Software - http://www.ashopsoftware.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see: http://www.gnu.org/licenses/.

include "config.inc.php";
include "ashopfunc.inc.php";
$adminlang = "en";
include "language/$adminlang/login.inc.php";
if (!$adminpanelcolor) $adminpanelcolor = "7589e7";
else $adminpanelcolor = str_replace("#","","$adminpanelcolor");
unset($shop);
unset($userid);
if (!$p3psent) header('P3P: CP="IDC DSP COR CURa ADMa OUR IND PHY ONL COM STA"');
$p3psent = TRUE;
SetCookie($userid,"");

// Initiate password hashing...
include "$ashoppath/includes/PasswordHash.php";
$passhasher = new PasswordHash(8, FALSE);

// Open database...
$db = @mysqli_connect("$databaseserver", "$databaseuser", "$databasepasswd", "$databasename");

// Handle password reset requests...
if (!empty($r) && !empty($u) && is_numeric($u)) {
	// Check the reset code...
	$result = @mysqli_query($db, "SELECT passwordreset FROM user WHERE userid='$u'");
	$resethash = @mysqli_result($result,0,"passwordreset");
	$resetcheck = $passhasher->CheckPassword($r, $resethash);
	if (!$resetcheck) {
		echo "<!DOCTYPE html>
<html>
  <head>
    ".CHARSET."
    <meta http-equiv=\"X-UA-Compatible\" content=\"IE=edge\">
    <title>$ashopname - ".ADMINPANELLOGIN."</title>
    <meta content=\"width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no\" name=\"viewport\">
    <link rel=\"stylesheet\" href=\"bootstrap/css/bootstrap.min.css\">
    <link rel=\"stylesheet\" href=\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\">
    <link rel=\"stylesheet\" href=\"https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css\">
    <link rel=\"stylesheet\" href=\"dist/css/AdminLTE.min.css\">
    <link rel=\"stylesheet\" href=\"dist/css/skins/skin-blue.min.css\">
	<link rel=\"stylesheet\" href=\"admin.css\">
    <!--[if lt IE 9]>
        <script src=\"https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js\"></script>
        <script src=\"https://oss.maxcdn.com/respond/1.4.2/respond.min.js\"></script>
    <![endif]-->
  </head>
  <body class=\"hold-transition login-page\">
    <div class=\"login-box\">
      <div class=\"login-logo\">
        <a href=\"login.php\"><img src=\"images/loginlogo.gif\" alt=\"B-Shop\" title=\"B-Shop\"></a>
      </div>
      <div class=\"login-box-body\">
        <p class=\"login-box-msg\">".INVALIDRESETCODE."<br><br>
		<a href=\"javascript:history.back()\">".TRYAGAIN."</a>
		</p>

      </div><!-- /.login-box-body -->
    </div><!-- /.login-box -->

    <!-- jQuery 2.1.4 -->
    <script src=\"plugins/jQuery/jQuery-2.1.4.min.js\"></script>
    <!-- Bootstrap 3.3.5 -->
    <script src=\"bootstrap/js/bootstrap.min.js\"></script>
  </body>
</html>";
		exit;
	}
	if (empty($newpassword)) {
		// Show password reset page in browser...
		echo "<!DOCTYPE html>
<html>
  <head>
    ".CHARSET."
    <meta http-equiv=\"X-UA-Compatible\" content=\"IE=edge\">
    <title>$ashopname - ".ADMINPANELLOGIN."</title>
    <meta content=\"width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no\" name=\"viewport\">
    <link rel=\"stylesheet\" href=\"bootstrap/css/bootstrap.min.css\">
    <link rel=\"stylesheet\" href=\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\">
    <link rel=\"stylesheet\" href=\"https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css\">
    <link rel=\"stylesheet\" href=\"dist/css/AdminLTE.min.css\">
    <link rel=\"stylesheet\" href=\"dist/css/skins/skin-blue.min.css\">
	<link rel=\"stylesheet\" href=\"admin.css\">
    <!--[if lt IE 9]>
        <script src=\"https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js\"></script>
        <script src=\"https://oss.maxcdn.com/respond/1.4.2/respond.min.js\"></script>
    <![endif]-->
  </head>
  <body class=\"hold-transition login-page\">
    <div class=\"login-box\">
      <div class=\"login-logo\">
        <a href=\"login.php\"><img src=\"images/loginlogo.gif\" alt=\"B-Shop\" title=\"B-Shop\"></a>
      </div>
      <div class=\"login-box-body\">
        <p class=\"login-box-msg\">".ENTERNEWPASS."</p>
        <form action=\"sendpass.php\" method=\"post\">
          <div class=\"form-group has-feedback\">
            <input type=\"password\" name=\"newpassword\" class=\"form-control\" placeholder=\"".NEWPASSWORD."\">
            <span class=\"glyphicon glyphicon-user form-control-feedback\"></span>
          </div>
          <div class=\"form-group has-feedback\">
            <input type=\"password\" name=\"confirm\" class=\"form-control\" placeholder=\"".CONFIRM."\">
            <span class=\"glyphicon glyphicon-user form-control-feedback\"></span>
          </div>
          <div class=\"row\">
            <div class=\"col-xs-6\">
            </div>
            <div class=\"col-xs-6\">
              <button type=\"submit\" class=\"btn btn-primary btn-block btn-flat\">".SUBMIT."</button>
            </div>
          </div>
        </form>

      </div><!-- /.login-box-body -->
    </div><!-- /.login-box -->

    <!-- jQuery 2.1.4 -->
    <script src=\"plugins/jQuery/jQuery-2.1.4.min.js\"></script>
    <!-- Bootstrap 3.3.5 -->
    <script src=\"bootstrap/js/bootstrap.min.js\"></script>
  </body>
</html>";
		exit;
	} else {
		if ($newpassword != $confirm) {
			echo "<!DOCTYPE html>
<html>
  <head>
    ".CHARSET."
    <meta http-equiv=\"X-UA-Compatible\" content=\"IE=edge\">
    <title>$ashopname - ".ADMINPANELLOGIN."</title>
    <meta content=\"width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no\" name=\"viewport\">
    <link rel=\"stylesheet\" href=\"bootstrap/css/bootstrap.min.css\">
    <link rel=\"stylesheet\" href=\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\">
    <link rel=\"stylesheet\" href=\"https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css\">
    <link rel=\"stylesheet\" href=\"dist/css/AdminLTE.min.css\">
    <link rel=\"stylesheet\" href=\"dist/css/skins/skin-blue.min.css\">
	<link rel=\"stylesheet\" href=\"admin.css\">
    <!--[if lt IE 9]>
        <script src=\"https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js\"></script>
        <script src=\"https://oss.maxcdn.com/respond/1.4.2/respond.min.js\"></script>
    <![endif]-->
  </head>
  <body class=\"hold-transition login-page\">
    <div class=\"login-box\">
      <div class=\"login-logo\">
        <a href=\"login.php\"><img src=\"images/loginlogo.gif\" alt=\"B-Shop\" title=\"B-Shop\"></a>
      </div>
      <div class=\"login-box-body\">
        <p class=\"login-box-msg\">".PASSWORDSDIDNOTMATCH."<br><br>
		<a href=\"javascript:history.back()\">".TRYAGAIN."</a>
		</p>

      </div><!-- /.login-box-body -->
    </div><!-- /.login-box -->

    <!-- jQuery 2.1.4 -->
    <script src=\"plugins/jQuery/jQuery-2.1.4.min.js\"></script>
    <!-- Bootstrap 3.3.5 -->
    <script src=\"bootstrap/js/bootstrap.min.js\"></script>
  </body>
</html>";
			exit;
		} else {
			$passwordhash = $passhasher->HashPassword($newpassword);
			@mysqli_query($db, "UPDATE user SET password='$passwordhash', passwordreset='' WHERE userid='$u'");
			echo "<!DOCTYPE html>
<html>
  <head>
    ".CHARSET."
    <meta http-equiv=\"X-UA-Compatible\" content=\"IE=edge\">
    <title>$ashopname - ".ADMINPANELLOGIN."</title>
    <meta content=\"width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no\" name=\"viewport\">
    <link rel=\"stylesheet\" href=\"bootstrap/css/bootstrap.min.css\">
    <link rel=\"stylesheet\" href=\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\">
    <link rel=\"stylesheet\" href=\"https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css\">
    <link rel=\"stylesheet\" href=\"dist/css/AdminLTE.min.css\">
    <link rel=\"stylesheet\" href=\"dist/css/skins/skin-blue.min.css\">
	<link rel=\"stylesheet\" href=\"admin.css\">
    <!--[if lt IE 9]>
        <script src=\"https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js\"></script>
        <script src=\"https://oss.maxcdn.com/respond/1.4.2/respond.min.js\"></script>
    <![endif]-->
  </head>
  <body class=\"hold-transition login-page\">
    <div class=\"login-box\">
      <div class=\"login-logo\">
        <a href=\"login.php\"><img src=\"images/loginlogo.gif\" alt=\"B-Shop\" title=\"B-Shop\"></a>
      </div>
      <div class=\"login-box-body\">
        <p class=\"login-box-msg\">".YOURPASSWORDHASBEENCHANGED."<br><br>
		<a href=\"login.php\">".ADMINPANELLOGIN."</a>
		</p>

      </div><!-- /.login-box-body -->
    </div><!-- /.login-box -->

    <!-- jQuery 2.1.4 -->
    <script src=\"plugins/jQuery/jQuery-2.1.4.min.js\"></script>
    <!-- Bootstrap 3.3.5 -->
    <script src=\"bootstrap/js/bootstrap.min.js\"></script>
  </body>
</html>";
			exit;
		}
	}
}

if (isset($user) && empty($user)) $user = "ashopadmin";

if ($user != "") {

	// Function for generating unique passwords...
	function makePassword() {
		$alphaNum = array('2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'm', 'n', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z');
		srand ((double) microtime() * 1000000);
		$pwLength = "7"; // this sets the limit on how long the password is.
		for($j = 1; $j <=$pwLength; $j++) {
			$newPass .= $alphaNum[(rand(0,31))];
		}
		return ($newPass);
	}

	// Generate a reset code...
	$resetcode = makePassword();
	$resethash = $passhasher->HashPassword($resetcode);

	// Get email from database...
	$sql="SELECT email,userid FROM user WHERE username='$user'";
	$result = @mysqli_query($db, "$sql");
	if (@mysqli_num_rows($result) != 0) {
		$email = @mysqli_result($result, 0, "email");
		$uid = @mysqli_result($result, 0, "userid");
		if (empty($email)) $email = $ashopemail;
	} else {
		unset($email);
	}

  if ($user && $email && $uid) {

	  // Store the reset hash..
	  @mysqli_query($db, "UPDATE user SET passwordreset='$resethash' WHERE username='$user'");

	  // Send message with password reset link...
	  if ($email == $ashopemail) $subject="$ashopname - ".ADMINPANELPASSWORD;
	  else $subject="$ashopname - ".SHOPPINGMALLPASSWORD;
	  $message="<html><head><title>".YOURSHOPPINGMALLPASSWORD."</title></head><body><font face=\"$font\"><p>".YOURPASSWORDFOR." $ashopname ".CANBEGHANGED.": <a href=\"$ashopurl/admin/sendpass.php?r=$resetcode&u=$uid\">$ashopurl/admin/sendpass.php?r=$resetcode&u=$uid</a></p></font></body></html>";
	  $headers = "From: $ashopname<$ashopemail>\nX-Sender: <$ashopemail>\nX-Mailer: PHP\nX-Priority: 3\nReturn-Path: <$ashopemail>\nMIME-Version: 1.0\nContent-Type: text/html; charset=iso-8859-1\n";
	  @ashop_mail("$email","$subject","$message","$headers");
  }

  // Close database...
  @mysqli_close($db);

  // Tell shopping mall user that the password reset code has been sent...
  if ($user && $email && $uid && $resetcode) {
	  echo "<!DOCTYPE html>
<html>
  <head>
    ".CHARSET."
    <meta http-equiv=\"X-UA-Compatible\" content=\"IE=edge\">
    <title>$ashopname - ".ADMINPANELLOGIN."</title>
    <meta content=\"width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no\" name=\"viewport\">
    <link rel=\"stylesheet\" href=\"bootstrap/css/bootstrap.min.css\">
    <link rel=\"stylesheet\" href=\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\">
    <link rel=\"stylesheet\" href=\"https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css\">
    <link rel=\"stylesheet\" href=\"dist/css/AdminLTE.min.css\">
    <link rel=\"stylesheet\" href=\"dist/css/skins/skin-blue.min.css\">
	<link rel=\"stylesheet\" href=\"admin.css\">
    <!--[if lt IE 9]>
        <script src=\"https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js\"></script>
        <script src=\"https://oss.maxcdn.com/respond/1.4.2/respond.min.js\"></script>
    <![endif]-->
  </head>
  <body class=\"hold-transition login-page\">
    <div class=\"login-box\">
      <div class=\"login-logo\">
        <a href=\"login.php\"><img src=\"images/loginlogo.gif\" alt=\"B-Shop\" title=\"B-Shop\"></a>
      </div>
      <div class=\"login-box-body\">
        <p class=\"login-box-msg\">".YOURPASSWORDHASBEENSENT."<br><br>
		<a href=\"login.php\">".ADMINPANELLOGIN."</a>
		</p>

      </div><!-- /.login-box-body -->
    </div><!-- /.login-box -->

    <!-- jQuery 2.1.4 -->
    <script src=\"plugins/jQuery/jQuery-2.1.4.min.js\"></script>
    <!-- Bootstrap 3.3.5 -->
    <script src=\"bootstrap/js/bootstrap.min.js\"></script>
  </body>
</html>";
	exit;
  } else {
	  echo "<!DOCTYPE html>
<html>
  <head>
    ".CHARSET."
    <meta http-equiv=\"X-UA-Compatible\" content=\"IE=edge\">
    <title>$ashopname - ".ADMINPANELLOGIN."</title>
    <meta content=\"width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no\" name=\"viewport\">
    <link rel=\"stylesheet\" href=\"bootstrap/css/bootstrap.min.css\">
    <link rel=\"stylesheet\" href=\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\">
    <link rel=\"stylesheet\" href=\"https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css\">
    <link rel=\"stylesheet\" href=\"dist/css/AdminLTE.min.css\">
    <link rel=\"stylesheet\" href=\"dist/css/skins/skin-blue.min.css\">
	<link rel=\"stylesheet\" href=\"admin.css\">
    <!--[if lt IE 9]>
        <script src=\"https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js\"></script>
        <script src=\"https://oss.maxcdn.com/respond/1.4.2/respond.min.js\"></script>
    <![endif]-->
  </head>
  <body class=\"hold-transition login-page\">
    <div class=\"login-box\">
      <div class=\"login-logo\">
        <a href=\"login.php\"><img src=\"images/loginlogo.gif\" alt=\"B-Shop\" title=\"B-Shop\"></a>
      </div>
      <div class=\"login-box-body\">
        <p class=\"login-box-msg\">".NOTREGISTERED."<br><br>
		<a href=\"javascript:history.back()\">".TRYAGAIN."</a>
		</p>

      </div><!-- /.login-box-body -->
    </div><!-- /.login-box -->

    <!-- jQuery 2.1.4 -->
    <script src=\"plugins/jQuery/jQuery-2.1.4.min.js\"></script>
    <!-- Bootstrap 3.3.5 -->
    <script src=\"bootstrap/js/bootstrap.min.js\"></script>
  </body>
</html>";
	exit;
  }
}

// Show send password page in browser...
echo "<!DOCTYPE html>
<html>
  <head>
    ".CHARSET."
    <meta http-equiv=\"X-UA-Compatible\" content=\"IE=edge\">
    <title>$ashopname - ".ADMINPANELLOGIN."</title>
    <meta content=\"width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no\" name=\"viewport\">
    <link rel=\"stylesheet\" href=\"bootstrap/css/bootstrap.min.css\">
    <link rel=\"stylesheet\" href=\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\">
    <link rel=\"stylesheet\" href=\"https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css\">
    <link rel=\"stylesheet\" href=\"dist/css/AdminLTE.min.css\">
    <link rel=\"stylesheet\" href=\"dist/css/skins/skin-blue.min.css\">
	<link rel=\"stylesheet\" href=\"admin.css\">
    <!--[if lt IE 9]>
        <script src=\"https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js\"></script>
        <script src=\"https://oss.maxcdn.com/respond/1.4.2/respond.min.js\"></script>
    <![endif]-->
  </head>
  <body class=\"hold-transition login-page\">
    <div class=\"login-box\">
      <div class=\"login-logo\">
        <a href=\"login.php\"><img src=\"images/loginlogo.gif\" alt=\"B-Shop\" title=\"B-Shop\"></a>
      </div>
      <div class=\"login-box-body\">
        <p class=\"login-box-msg\">".ENTERUSERNAMEANDWEWILLSENDPASS."</p>
        <form action=\"sendpass.php\" method=\"post\">
          <div class=\"form-group has-feedback\">
            <input type=\"username\" name=\"user\" class=\"form-control\" placeholder=\"".USERNAME."\">
            <span class=\"glyphicon glyphicon-user form-control-feedback\"></span>
          </div>
          <div class=\"row\">
            <div class=\"col-xs-6\">
            </div>
            <div class=\"col-xs-6\">
              <button type=\"submit\" class=\"btn btn-primary btn-block btn-flat\">".SUBMIT."</button>
            </div>
          </div>
        </form>

      </div><!-- /.login-box-body -->
    </div><!-- /.login-box -->

    <!-- jQuery 2.1.4 -->
    <script src=\"plugins/jQuery/jQuery-2.1.4.min.js\"></script>
    <!-- Bootstrap 3.3.5 -->
    <script src=\"bootstrap/js/bootstrap.min.js\"></script>
  </body>
</html>
";
?>